
    .MODEL SMALL

    JUMPS                       ;; deal with long jump displacements 
                                ;; automatically
    include global.inc

    .CODE                       ;; extablish the default segment

    include debug.inc
    include log.inc
    include timer.inc
    include tasks.inc
    include buffer.inc
    include queue.inc

        ;; files for hardware support
    include packet.inc
    include pps.inc              ;; needed for packet slip only
    include pp.inc               ;; needed for packet slip only

        ;; high level code
    include if.inc
    include ether.inc
    include arptab.inc
    include arp.inc
    include dl_ip.inc
    include rip.inc
    include ip.inc
    include icmp.inc
    include udp.inc
    include bootp.inc 

    DB_DECLARE                  ;; declare debugging routines

    cur_dl = 1

    ;; this is a packet driver entry
    PKT_DECLARE %cur_dl, 60H, 01, 1514, 10240 ;; <name>, <Int Num> <Class (Eth=1)>
    IF_DECLARE %cur_dl, %cur_dl, PKT        ;; <if name>, <real if>, <prefix>
    ETH_DECLARE %cur_dl, %cur_dl, %cur_dl   ;; <eth name>, <if>, <task> 
    ARP_DECLARE %cur_dl, %cur_dl            ;; <arp name>, <ether>
    DL_IP_DECLARE %cur_dl, %cur_dl, ARP     ;; <dlip name>, <real dlip> <prefix>
    cur_dl = cur_dl + 1

    ;; this is a packet slip driver entry
    PPS_DECLARE %cur_dl
    PKT_DECLARE %cur_dl, 61H, 06, 1500, 10240 ;; <name>, <Int Num> <Class (Slip=6)>
    IF_DECLARE %cur_dl, %cur_dl, PKT
    PP_DECLARE %cur_dl, %cur_dl, %cur_dl
    DL_IP_DECLARE %cur_dl, %cur_dl, PP      ;; <dlip name>, <real dlip> <prefix>
    cur_dl = cur_dl + 1

    ;; this is a packet slip driver entry
    PPS_DECLARE %cur_dl
    PKT_DECLARE %cur_dl, 62H, 06, 1500, 10240 ;; <name>, <Int Num> <Class (Slip=6)>
    IF_DECLARE %cur_dl, %cur_dl, PKT
    PP_DECLARE %cur_dl, %cur_dl, %cur_dl
    DL_IP_DECLARE %cur_dl, %cur_dl, PP      ;; <dlip name>, <real dlip> <prefix>
    cur_dl = cur_dl + 1

;; end of declarations
;;****************************************************************************

    num_dls = cur_dl - 1
    task_timer = cur_dl
    num_tasks  = cur_dl

    SCHED_DECLARE %num_tasks

    mytimer     = 10                        ;; WD_DECLARE Depends on this value
    TIMER_DECLARE %mytimer, %task_timer

    myip = 11
    myrip = 12
    myicmp = 13
    myudp = 14
    mybootp = 15
    mylog = 16
    dlog = 17
    IP_DECLARE %myip, %myrip, %num_dls, %myicmp
    UDP_DECLARE %myudp, %myip, %myicmp
    RIP_DECLARE %myrip, %myip, %mytimer, %myudp
    ICMP_DECLARE %myicmp, %myip, %myrip
    BOOTP_DECLARE %mybootp, %myudp, %num_dls
    LOG_DECLARE %mylog, LOG_LOCAL0, %myudp, %mytimer
